diff --git a/game/core/src/main/java/net/minecraft/core/world/chunk/ChunkSection.java b/game/core/src/main/java/net/minecraft/core/world/chunk/ChunkSection.java
index 037998bc3..698845cb7 100644
--- a/game/core/src/main/java/net/minecraft/core/world/chunk/ChunkSection.java
+++ b/game/core/src/main/java/net/minecraft/core/world/chunk/ChunkSection.java
@@ -4,9 +4,9 @@ import net.minecraft.core.block.Blocks;
 import net.minecraft.core.data.registry.Registries;
 import net.minecraft.core.entity.Entity;
 import net.minecraft.core.enums.LightLayer;
+import net.minecraft.core.util.helper.LightIndexHelper;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.biome.Biome;
-import net.minecraft.core.world.data.ChunkNibbleArray;
 import net.minecraft.core.world.data.ChunkUnsignedByteArray;
 import net.minecraft.core.world.pos.ChunkSectionTilePos;
 import net.minecraft.core.world.pos.ChunkSectionTilePosc;
@@ -29,8 +29,7 @@ public class ChunkSection {
 
     public short @Nullable [] blocks;
     public @Nullable ChunkUnsignedByteArray data = null;
-    public @Nullable ChunkNibbleArray skylightMap = null;
-    public @Nullable ChunkNibbleArray blocklightMap = null;
+    public byte @Nullable [] lightData = null;
     public byte @NotNull [] biome = new byte[Chunk.CHUNK_SIZE_X * Chunk.CHUNK_SIZE_Z * (SECTION_SIZE_Y >> 3)];
     public @NotNull List<@NotNull Entity> entities = new ArrayList<>();
 
@@ -41,8 +40,7 @@ public class ChunkSection {
 
     public void init() {
         this.data = new ChunkUnsignedByteArray(Chunk.CHUNK_SIZE_X, SECTION_SIZE_Y, Chunk.CHUNK_SIZE_Z);
-        this.skylightMap = new ChunkNibbleArray(Chunk.CHUNK_SIZE_X, SECTION_SIZE_Y, Chunk.CHUNK_SIZE_Z);
-        this.blocklightMap = new ChunkNibbleArray(Chunk.CHUNK_SIZE_X, SECTION_SIZE_Y, Chunk.CHUNK_SIZE_Z);
+        this.lightData = new byte[Chunk.CHUNK_SIZE_X * SECTION_SIZE_Y * Chunk.CHUNK_SIZE_Z];
         Arrays.fill(this.biome, (byte) -1);
     }
 
@@ -78,8 +76,6 @@ public class ChunkSection {
     }
 
     public void setBlockId(final @NotNull ChunkSectionTilePosc sectionPos, final int id) {
-        assert Blocks.getBlock(id) != null;
-
         if (!sectionPos.inBounds() || (this.blocks == null && id == Blocks.AIR.id())) {
             return;
         } else if (this.blocks == null) {
@@ -158,25 +154,18 @@ public class ChunkSection {
         this.setBiome(new ChunkSectionTilePos(x, y, z), biome);
     }
 
-    public int getBrightness(final @NotNull LightLayer lightLayer, final @NotNull ChunkSectionTilePosc sectionPos) {
+    public int getLightLevel(final @NotNull LightLayer lightLayer, final @NotNull ChunkSectionTilePosc sectionPos) {
         if (!sectionPos.inBounds()) {
             return 0;
         }
 
+        if (this.lightData == null) return 0;
         switch (lightLayer) {
             case Sky -> {
-                if (this.skylightMap == null) {
-                    return 0;
-                }
-
-                return this.skylightMap.get(sectionPos.x(), sectionPos.y(), sectionPos.z());
+                return LightIndexHelper.skyLightFromIndex(this.lightData[makeBlockIndex(sectionPos)]);
             }
             case Block -> {
-                if (this.blocklightMap == null) {
-                    return 0;
-                }
-
-                return this.blocklightMap.get(sectionPos.x(), sectionPos.y(), sectionPos.z());
+                return LightIndexHelper.blockLightFromIndex(this.lightData[makeBlockIndex(sectionPos)]);
             }
             default -> {
                 return 0;
@@ -184,50 +173,51 @@ public class ChunkSection {
         }
     }
 
+    public byte getLightIndex(final @NotNull ChunkSectionTilePosc sectionPos) {
+        if (!sectionPos.inBounds()) {
+            return 0;
+        }
+        if (this.lightData == null) return 0;
+        return this.lightData[makeBlockIndex(sectionPos)];
+    }
+
     @Deprecated
     public int getBrightness(final @NotNull LightLayer lightLayer, final int x, final int y, final int z) {
-        return this.getBrightness(lightLayer, new ChunkSectionTilePos(x, y, z));
+        return this.getLightLevel(lightLayer, new ChunkSectionTilePos(x, y, z));
     }
 
-    public void setBrightness(final @NotNull LightLayer lightLayer, final @NotNull ChunkSectionTilePosc sectionPos, final int brightness) {
+    public void setLightLevel(final @NotNull LightLayer lightLayer, final @NotNull ChunkSectionTilePosc sectionPos, final int brightness) {
         if (!sectionPos.inBounds()) {
             return;
         }
 
-        switch (lightLayer) {
-            case Sky -> {
-                if (this.skylightMap == null) {
-                    this.skylightMap = new ChunkNibbleArray(Chunk.CHUNK_SIZE_X, SECTION_SIZE_Y, Chunk.CHUNK_SIZE_Z);
-                }
-
-                this.skylightMap.set(sectionPos.x(), sectionPos.y(), sectionPos.z(), brightness);
-            }
-            case Block -> {
-                if (this.blocklightMap == null) {
-                    this.blocklightMap = new ChunkNibbleArray(Chunk.CHUNK_SIZE_X, SECTION_SIZE_Y, Chunk.CHUNK_SIZE_Z);
-                }
+        if (this.lightData == null) {
+            this.lightData = new byte[Chunk.CHUNK_SIZE_X * SECTION_SIZE_Y * Chunk.CHUNK_SIZE_Z];
+        }
 
-                this.blocklightMap.set(sectionPos.x(), sectionPos.y(), sectionPos.z(), brightness);
-            }
+        int index = makeBlockIndex(sectionPos);
+        switch (lightLayer) {
+            case Sky -> this.lightData[index] = LightIndexHelper.setSkyLight(this.lightData[index], brightness);
+            case Block -> this.lightData[index] = LightIndexHelper.setBlockLight(this.lightData[index], brightness);
         }
     }
 
     @Deprecated
     public void setBrightness(final @NotNull LightLayer lightLayer, final int x, final int y, final int z, final int brightness) {
-        this.setBrightness(lightLayer, new ChunkSectionTilePos(x, y, z), brightness);
+        this.setLightLevel(lightLayer, new ChunkSectionTilePos(x, y, z), brightness);
     }
 
-    public int getRawBrightness(final @NotNull ChunkSectionTilePosc sectionPos, final int subtractedSkyLight) {
+    public int getRawSkyLightLevel(final @NotNull ChunkSectionTilePosc sectionPos, final int subtractedSkyLight) {
         if (!sectionPos.inBounds()) {
             return 0;
         }
 
-        return Math.max(this.getBrightness(LightLayer.Sky, sectionPos) - subtractedSkyLight, this.getBrightness(LightLayer.Block, sectionPos));
+        return Math.max(this.getLightLevel(LightLayer.Sky, sectionPos) - subtractedSkyLight, this.getLightLevel(LightLayer.Block, sectionPos));
     }
 
     @Deprecated
     public int getRawBrightness(final int x, final int y, final int z, final int subtractedSkyLight) {
-        return this.getRawBrightness(new ChunkSectionTilePos(x, y, z), subtractedSkyLight);
+        return this.getRawSkyLightLevel(new ChunkSectionTilePos(x, y, z), subtractedSkyLight);
     }
 
     public void addEntity(final @NotNull Entity entity) {
@@ -314,42 +304,23 @@ public class ChunkSection {
             }
         }
 
-        // Read skylight
-        if (data[startIndex++] == 1) {
-            if (this.skylightMap == null || this.skylightMap.data == null) {
-                this.skylightMap = new ChunkNibbleArray(Chunk.CHUNK_SIZE_X, SECTION_SIZE_Y, Chunk.CHUNK_SIZE_Z);
-            }
-
-            for (int cy = minY; cy < maxY; cy++) {
-                for (int cz = minZ; cz < maxZ; cz++) {
-                    int cIndex = makeBlockIndex(minX, cy, cz) / 2;
-                    System.arraycopy(data, startIndex, this.skylightMap.data, cIndex, xSize / 2);
-                    startIndex += xSize / 2;
-                }
-            }
-        }
-
-        // Read blocklight
+        // Read LightData
         if (data[startIndex++] == 1) {
-            if (this.blocklightMap == null || this.blocklightMap.data == null) {
-                this.blocklightMap = new ChunkNibbleArray(Chunk.CHUNK_SIZE_X, SECTION_SIZE_Y, Chunk.CHUNK_SIZE_Z);
+            if (this.lightData == null) {
+                this.lightData = new byte[Chunk.CHUNK_SIZE_X * SECTION_SIZE_Y * Chunk.CHUNK_SIZE_Z];
             }
 
             for (int cy = minY; cy < maxY; cy++) {
                 for (int cz = minZ; cz < maxZ; cz++) {
-                    int cIndex = makeBlockIndex(minX, cy, cz) / 2;
-                    System.arraycopy(data, startIndex, this.blocklightMap.data, cIndex, xSize / 2);
-                    startIndex += xSize / 2;
+                    int cIndex = makeBlockIndex(minX, cy, cz);
+                    System.arraycopy(data, startIndex, this.lightData, cIndex, xSize);
+                    startIndex += xSize;
                 }
             }
         }
 
         // Read biomes
         if (data[startIndex++] == 1) {
-            if (this.biome == null) {
-                this.biome = new byte[Chunk.CHUNK_SIZE_X * Chunk.CHUNK_SIZE_Z * (SECTION_SIZE_Y >> 3)];
-            }
-
             for (int cy = minY >> 3; cy < maxY >> 3; cy++) {
                 for (int cz = minZ; cz < maxZ; cz++) {
                     int cIndex = makeBlockIndex(minX, cy, cz);
@@ -393,32 +364,19 @@ public class ChunkSection {
                 data[startIndex++] = 0;
             }
 
-            // Write skylight
-            if (this.skylightMap != null && this.skylightMap.isValid() && this.skylightMap.data != null) {
-                data[startIndex++] = 1;
-                System.arraycopy(this.skylightMap.data, 0, data, startIndex, this.skylightMap.data.length);
-                startIndex += this.skylightMap.data.length;
-            } else {
-                data[startIndex++] = 0;
-            }
-
-            // Write blocklight
-            if (this.blocklightMap != null && this.blocklightMap.isValid() && this.blocklightMap.data != null) {
+            // Write lightData
+            if (this.lightData != null) {
                 data[startIndex++] = 1;
-                System.arraycopy(this.blocklightMap.data, 0, data, startIndex, this.blocklightMap.data.length);
-                startIndex += this.blocklightMap.data.length;
+                System.arraycopy(this.lightData, 0, data, startIndex, this.lightData.length);
+                startIndex += this.lightData.length;
             } else {
                 data[startIndex++] = 0;
             }
 
             // Write biomes
-            if (this.biome != null) {
-                data[startIndex++] = 1;
-                System.arraycopy(this.biome, 0, data, startIndex, this.biome.length);
-                startIndex += this.biome.length;
-            } else {
-                data[startIndex++] = 0;
-            }
+            data[startIndex++] = 1;
+            System.arraycopy(this.biome, 0, data, startIndex, this.biome.length);
+            startIndex += this.biome.length;
         } else {
             // Write blocks
             if (this.blocks != null) {
@@ -448,28 +406,14 @@ public class ChunkSection {
                 data[startIndex++] = 0;
             }
 
-            // Write skylight
-            if (this.skylightMap != null && this.skylightMap.isValid() && this.skylightMap.data != null) {
-                data[startIndex++] = 1;
-                for (int cy = minY; cy < maxY; cy++) {
-                    for (int cz = minZ; cz < maxZ; cz++) {
-                        int cIndex = makeBlockIndex(minX, cy, cz) / 2;
-                        System.arraycopy(this.skylightMap.data, cIndex, data, startIndex, xSize / 2);
-                        startIndex += xSize / 2;
-                    }
-                }
-            } else {
-                data[startIndex++] = 0;
-            }
-
-            // Write blocklight
-            if (this.blocklightMap != null && this.blocklightMap.isValid() && this.blocklightMap.data != null) {
+            // Write light data
+            if (this.lightData != null) {
                 data[startIndex++] = 1;
                 for (int cy = minY; cy < maxY; cy++) {
                     for (int cz = minZ; cz < maxZ; cz++) {
-                        int cIndex = makeBlockIndex(minX, cy, cz) / 2;
-                        System.arraycopy(this.blocklightMap.data, cIndex, data, startIndex, xSize / 2);
-                        startIndex += xSize / 2;
+                        int cIndex = makeBlockIndex(minX, cy, cz);
+                        System.arraycopy(this.lightData, cIndex, data, startIndex, xSize);
+                        startIndex += xSize;
                     }
                 }
             } else {
@@ -477,17 +421,13 @@ public class ChunkSection {
             }
 
             // Write biomes
-            if (this.biome != null) {
-                data[startIndex++] = 1;
-                for (int cy = minY >> 3; cy < maxY >> 3; cy++) {
-                    for (int cz = minZ; cz < maxZ; cz++) {
-                        int cIndex = makeBlockIndex(minX, cy, cz);
-                        System.arraycopy(this.biome, cIndex, data, startIndex, xSize);
-                        startIndex += xSize;
-                    }
+            data[startIndex++] = 1;
+            for (int cy = minY >> 3; cy < maxY >> 3; cy++) {
+                for (int cz = minZ; cz < maxZ; cz++) {
+                    int cIndex = makeBlockIndex(minX, cy, cz);
+                    System.arraycopy(this.biome, cIndex, data, startIndex, xSize);
+                    startIndex += xSize;
                 }
-            } else {
-                data[startIndex++] = 0;
             }
         }
 
diff --git a/game/core/src/main/java/net/minecraft/core/world/chunk/DisplayChunk.java b/game/core/src/main/java/net/minecraft/core/world/chunk/DisplayChunk.java
index 125eebb7a..bf17d9bf7 100644
--- a/game/core/src/main/java/net/minecraft/core/world/chunk/DisplayChunk.java
+++ b/game/core/src/main/java/net/minecraft/core/world/chunk/DisplayChunk.java
@@ -44,7 +44,7 @@ public class DisplayChunk extends EmptyChunk{
     }
 
     @Override
-    public int getBrightness(final @NotNull LightLayer lightLayer, final @NotNull ChunkTilePosc tilePos) {
+    public int getLightLevel(final @NotNull LightLayer lightLayer, final @NotNull ChunkTilePosc tilePos) {
         return 15;
     }
 
diff --git a/game/core/src/main/java/net/minecraft/core/world/chunk/EmptyChunk.java b/game/core/src/main/java/net/minecraft/core/world/chunk/EmptyChunk.java
index 3b5134788..102286a8c 100644
--- a/game/core/src/main/java/net/minecraft/core/world/chunk/EmptyChunk.java
+++ b/game/core/src/main/java/net/minecraft/core/world/chunk/EmptyChunk.java
@@ -63,15 +63,15 @@ public class EmptyChunk extends Chunk {
     }
 
     @Override
-    public int getBrightness(final @NotNull LightLayer lightLayer, final @NotNull ChunkTilePosc tilePos) {
+    public int getLightLevel(final @NotNull LightLayer lightLayer, final @NotNull ChunkTilePosc tilePos) {
         return 0;
     }
 
     @Override
-    public void setBrightness(final @NotNull LightLayer lightLayer, final @NotNull ChunkTilePosc tilePos, final int value) { }
+    public void setLightLevel(final @NotNull LightLayer lightLayer, final @NotNull ChunkTilePosc tilePos, final int value) { }
 
     @Override
-    public int getRawBrightness(final @NotNull ChunkTilePosc tilePos, final int subtractedSkyLight) {
+    public int getRawSkyLightLevel(final @NotNull ChunkTilePosc tilePos, final int subtractedSkyLight) {
         return 0;
     }
 
diff --git a/game/core/src/main/java/net/minecraft/core/world/chunk/reader/ChunkReaderLegacy.java b/game/core/src/main/java/net/minecraft/core/world/chunk/reader/ChunkReaderLegacy.java
index ba7343ad4..6085e74d0 100644
--- a/game/core/src/main/java/net/minecraft/core/world/chunk/reader/ChunkReaderLegacy.java
+++ b/game/core/src/main/java/net/minecraft/core/world/chunk/reader/ChunkReaderLegacy.java
@@ -2,7 +2,6 @@ package net.minecraft.core.world.chunk.reader;
 
 import com.mojang.nbt.tags.CompoundTag;
 import it.unimi.dsi.fastutil.ints.Int2ObjectMap;
-import it.unimi.dsi.fastutil.longs.Long2ObjectMap;
 import net.minecraft.core.NextTickListEntry;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.chunk.Chunk;
@@ -12,8 +11,6 @@ import net.minecraft.core.world.data.ChunkUnsignedByteArray;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 
-import java.util.Map;
-
 public class ChunkReaderLegacy
     extends ChunkReader
 {
@@ -36,22 +33,22 @@ public class ChunkReaderLegacy
     {
         super(world, tag);
 
-        blocks = tag.getShortArrayOrDefault("Blocks", null);
-        data = tag.getByteArrayOrDefault("Data", null);
-        skylight = tag.getByteArrayOrDefault("SkyLight", null);
-        blocklight = tag.getByteArrayOrDefault("BlockLight", null);
+        this.blocks = tag.getShortArrayOrDefault("Blocks", null);
+        this.data = tag.getByteArrayOrDefault("Data", null);
+        this.skylight = tag.getByteArrayOrDefault("SkyLight", null);
+        this.blocklight = tag.getByteArrayOrDefault("BlockLight", null);
     }
 
     @Override
     public int getX()
     {
-        return tag.getInteger("xPos");
+        return this.tag.getInteger("xPos");
     }
 
     @Override
     public int getZ()
     {
-        return tag.getInteger("zPos");
+        return this.tag.getInteger("zPos");
     }
 
     @Override
@@ -65,7 +62,7 @@ public class ChunkReaderLegacy
     {
         short[] newBlocks = new short[Chunk.CHUNK_SIZE_X * ChunkSection.SECTION_SIZE_Y * Chunk.CHUNK_SIZE_Z];
 
-        if (blocks != null && makeBlockIndex(15, (ySection * ChunkSection.SECTION_SIZE_Y) + 15, 15) < blocks.length) {
+        if (this.blocks != null && makeBlockIndex(15, (ySection * ChunkSection.SECTION_SIZE_Y) + 15, 15) < this.blocks.length) {
             for (int x = 0; x < 16; x++) {
                 for (int z = 0; z < 16; z++) {
                     for (int y = 0; y < 16; y++) {
@@ -86,7 +83,7 @@ public class ChunkReaderLegacy
         byte[] newData = new byte[Chunk.CHUNK_SIZE_X * ChunkSection.SECTION_SIZE_Y * Chunk.CHUNK_SIZE_Z];
         ChunkUnsignedByteArray array = new ChunkUnsignedByteArray(Chunk.CHUNK_SIZE_X, ChunkSection.SECTION_SIZE_Y, Chunk.CHUNK_SIZE_Z, newData);
 
-        if (data != null && makeBlockIndex(15, (ySection * ChunkSection.SECTION_SIZE_Y) + 15, 15) < data.length) {
+        if (this.data != null && makeBlockIndex(15, (ySection * ChunkSection.SECTION_SIZE_Y) + 15, 15) < this.data.length) {
             for (int x = 0; x < 16; x++) {
                 for (int z = 0; z < 16; z++) {
                     for (int y = 0; y < 16; y++) {
@@ -102,12 +99,12 @@ public class ChunkReaderLegacy
     }
 
     @Override
-    public @NotNull ChunkNibbleArray getSkyLight(int ySection)
+    public @Nullable ChunkNibbleArray getSkyLight(int ySection)
     {
         byte[] newSkyLight = new byte[(Chunk.CHUNK_SIZE_X * ChunkSection.SECTION_SIZE_Y * Chunk.CHUNK_SIZE_Z) >> 1];
         ChunkNibbleArray array = new ChunkNibbleArray(Chunk.CHUNK_SIZE_X, ChunkSection.SECTION_SIZE_Y, Chunk.CHUNK_SIZE_Z, newSkyLight);
 
-        if (skylight != null && makeNibbleIndex(15, (ySection * ChunkSection.SECTION_SIZE_Y) + 15, 15) < skylight.length * 2) {
+        if (this.skylight != null && makeNibbleIndex(15, (ySection * ChunkSection.SECTION_SIZE_Y) + 15, 15) < this.skylight.length * 2) {
             for (int x = 0; x < 16; x++) {
                 for (int z = 0; z < 16; z++) {
                     for (int y = 0; y < 16; y++) {
@@ -117,9 +114,9 @@ public class ChunkReaderLegacy
                         int nibblePart = index & 0x01;
                         int nibble;
                         if (nibblePart == 0) {
-                            nibble = Byte.toUnsignedInt(skylight[nibbleIndex]) & 0x0F;
+                            nibble = Byte.toUnsignedInt(this.skylight[nibbleIndex]) & 0x0F;
                         } else {
-                            nibble = (Byte.toUnsignedInt(skylight[nibbleIndex]) >> 4) & 0x0F;
+                            nibble = (Byte.toUnsignedInt(this.skylight[nibbleIndex]) >> 4) & 0x0F;
                         }
                         array.set(x, y, z, nibble);
                     }
@@ -131,12 +128,12 @@ public class ChunkReaderLegacy
     }
 
     @Override
-    public @NotNull ChunkNibbleArray getBlockLight(int ySection)
+    public @Nullable ChunkNibbleArray getBlockLight(int ySection)
     {
         byte[] newBlockLight = new byte[(Chunk.CHUNK_SIZE_X * ChunkSection.SECTION_SIZE_Y * Chunk.CHUNK_SIZE_Z) >> 1];
         ChunkNibbleArray array = new ChunkNibbleArray(Chunk.CHUNK_SIZE_X, ChunkSection.SECTION_SIZE_Y, Chunk.CHUNK_SIZE_Z, newBlockLight);
 
-        if (blocklight != null && makeNibbleIndex(15, (ySection * ChunkSection.SECTION_SIZE_Y) + 15, 15) < blocklight.length * 2) {
+        if (this.blocklight != null && makeNibbleIndex(15, (ySection * ChunkSection.SECTION_SIZE_Y) + 15, 15) < this.blocklight.length * 2) {
             for (int x = 0; x < 16; x++) {
                 for (int z = 0; z < 16; z++) {
                     for (int y = 0; y < 16; y++) {
@@ -146,9 +143,9 @@ public class ChunkReaderLegacy
                         int nibblePart = index & 0x01;
                         int nibble;
                         if (nibblePart == 0) {
-                            nibble = Byte.toUnsignedInt(blocklight[nibbleIndex]) & 0x0F;
+                            nibble = Byte.toUnsignedInt(this.blocklight[nibbleIndex]) & 0x0F;
                         } else {
-                            nibble = (Byte.toUnsignedInt(blocklight[nibbleIndex]) >> 4) & 0x0F;
+                            nibble = (Byte.toUnsignedInt(this.blocklight[nibbleIndex]) >> 4) & 0x0F;
                         }
                         array.set(x, y, z, nibble);
                     }
@@ -162,7 +159,7 @@ public class ChunkReaderLegacy
     @Override
     public short @NotNull [] getHeightMap()
     {
-        return tag.getShortArrayOrDefault("HeightMap", null);
+        return this.tag.getShortArrayOrDefault("HeightMap", null);
     }
 
     @Override
@@ -175,7 +172,7 @@ public class ChunkReaderLegacy
     @Override
     public boolean getIsTerrainPopulated()
     {
-        return tag.getBoolean("TerrainPopulated");
+        return this.tag.getBoolean("TerrainPopulated");
     }
 
     @Override
diff --git a/game/core/src/main/java/net/minecraft/core/world/chunk/reader/ChunkReaderVersion1.java b/game/core/src/main/java/net/minecraft/core/world/chunk/reader/ChunkReaderVersion1.java
index 814e18d21..5de21fa4d 100644
--- a/game/core/src/main/java/net/minecraft/core/world/chunk/reader/ChunkReaderVersion1.java
+++ b/game/core/src/main/java/net/minecraft/core/world/chunk/reader/ChunkReaderVersion1.java
@@ -2,7 +2,6 @@ package net.minecraft.core.world.chunk.reader;
 
 import com.mojang.nbt.tags.CompoundTag;
 import it.unimi.dsi.fastutil.ints.Int2ObjectMap;
-import it.unimi.dsi.fastutil.longs.Long2ObjectMap;
 import net.minecraft.core.NextTickListEntry;
 import net.minecraft.core.data.registry.Registries;
 import net.minecraft.core.data.registry.Registry;
@@ -14,8 +13,6 @@ import net.minecraft.core.world.data.ChunkUnsignedByteArray;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 
-import java.util.Map;
-
 public class ChunkReaderVersion1
     extends ChunkReader {
     private final short[] blocks;
@@ -102,7 +99,7 @@ public class ChunkReaderVersion1
     }
 
     @Override
-    public @NotNull ChunkNibbleArray getSkyLight(final int ySection) {
+    public @Nullable ChunkNibbleArray getSkyLight(final int ySection) {
         final byte[] newSkyLight = new byte[(Chunk.CHUNK_SIZE_X * ChunkSection.SECTION_SIZE_Y * Chunk.CHUNK_SIZE_Z) >> 1];
         final ChunkNibbleArray array = new ChunkNibbleArray(Chunk.CHUNK_SIZE_X, ChunkSection.SECTION_SIZE_Y, Chunk.CHUNK_SIZE_Z, newSkyLight);
 
@@ -130,7 +127,7 @@ public class ChunkReaderVersion1
     }
 
     @Override
-    public @NotNull ChunkNibbleArray getBlockLight(final int ySection) {
+    public @Nullable ChunkNibbleArray getBlockLight(final int ySection) {
         final byte[] newBlockLight = new byte[(Chunk.CHUNK_SIZE_X * ChunkSection.SECTION_SIZE_Y * Chunk.CHUNK_SIZE_Z) >> 1];
         final ChunkNibbleArray array = new ChunkNibbleArray(Chunk.CHUNK_SIZE_X, ChunkSection.SECTION_SIZE_Y, Chunk.CHUNK_SIZE_Z, newBlockLight);
 
diff --git a/game/core/src/main/java/net/minecraft/core/world/chunk/reader/ChunkReaderVersion2.java b/game/core/src/main/java/net/minecraft/core/world/chunk/reader/ChunkReaderVersion2.java
index 4de091930..d7b8f5f06 100644
--- a/game/core/src/main/java/net/minecraft/core/world/chunk/reader/ChunkReaderVersion2.java
+++ b/game/core/src/main/java/net/minecraft/core/world/chunk/reader/ChunkReaderVersion2.java
@@ -4,7 +4,6 @@ import com.mojang.nbt.tags.CompoundTag;
 import com.mojang.nbt.tags.ListTag;
 import com.mojang.nbt.tags.Tag;
 import it.unimi.dsi.fastutil.ints.Int2ObjectMap;
-import it.unimi.dsi.fastutil.longs.Long2ObjectMap;
 import net.minecraft.core.NextTickListEntry;
 import net.minecraft.core.data.registry.Registries;
 import net.minecraft.core.data.registry.Registry;
@@ -17,7 +16,6 @@ import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 
 import java.util.Arrays;
-import java.util.Map;
 
 public class ChunkReaderVersion2
     extends ChunkReader {
@@ -86,7 +84,7 @@ public class ChunkReaderVersion2
     }
 
     @Override
-    public @NotNull ChunkNibbleArray getSkyLight(int ySection) {
+    public @Nullable ChunkNibbleArray getSkyLight(int ySection) {
         byte[] skylight = null;
         CompoundTag sectionTag = findSection(ySection);
         if (sectionTag != null) {
@@ -101,7 +99,7 @@ public class ChunkReaderVersion2
     }
 
     @Override
-    public @NotNull ChunkNibbleArray getBlockLight(int ySection) {
+    public @Nullable ChunkNibbleArray getBlockLight(int ySection) {
         byte[] blocklight = null;
         CompoundTag sectionTag = findSection(ySection);
         if (sectionTag != null) {
diff --git a/game/core/src/main/java/net/minecraft/core/world/chunk/reader/ChunkReaderVersion3.java b/game/core/src/main/java/net/minecraft/core/world/chunk/reader/ChunkReaderVersion3.java
index e4e790f6a..ac9fb11da 100644
--- a/game/core/src/main/java/net/minecraft/core/world/chunk/reader/ChunkReaderVersion3.java
+++ b/game/core/src/main/java/net/minecraft/core/world/chunk/reader/ChunkReaderVersion3.java
@@ -5,8 +5,6 @@ import com.mojang.nbt.tags.ListTag;
 import com.mojang.nbt.tags.Tag;
 import it.unimi.dsi.fastutil.ints.Int2ObjectArrayMap;
 import it.unimi.dsi.fastutil.ints.Int2ObjectMap;
-import it.unimi.dsi.fastutil.longs.Long2ObjectArrayMap;
-import it.unimi.dsi.fastutil.longs.Long2ObjectMap;
 import net.minecraft.core.NextTickListEntry;
 import net.minecraft.core.data.registry.Registries;
 import net.minecraft.core.data.registry.Registry;
diff --git a/game/core/src/main/java/net/minecraft/core/world/chunk/writer/ChunkWriter.java b/game/core/src/main/java/net/minecraft/core/world/chunk/writer/ChunkWriter.java
index 6298ae49a..babe967bf 100644
--- a/game/core/src/main/java/net/minecraft/core/world/chunk/writer/ChunkWriter.java
+++ b/game/core/src/main/java/net/minecraft/core/world/chunk/writer/ChunkWriter.java
@@ -8,7 +8,6 @@ import net.minecraft.core.NextTickListEntry;
 import net.minecraft.core.data.registry.Registries;
 import net.minecraft.core.data.registry.Registry;
 import net.minecraft.core.world.World;
-import net.minecraft.core.world.data.ChunkNibbleArray;
 import net.minecraft.core.world.data.ChunkUnsignedByteArray;
 import org.jetbrains.annotations.NotNull;
 
@@ -73,14 +72,14 @@ public class ChunkWriter
         findSection(ySection).putByteArray("Data", data.data);
     }
 
-    public void putSkyLight(int ySection, ChunkNibbleArray skyLight)
+    public void putSkyLight(int ySection, byte[] skyLightData)
     {
-        findSection(ySection).putByteArray("SkyLight", skyLight.data);
+        findSection(ySection).putByteArray("SkyLight", skyLightData);
     }
 
-    public void putBlockLight(int ySection, ChunkNibbleArray blockLight)
+    public void putBlockLight(int ySection, byte[] blockLightData)
     {
-        findSection(ySection).putByteArray("BlockLight", blockLight.data);
+        findSection(ySection).putByteArray("BlockLight", blockLightData);
     }
 
     public void putHeightMap(short[] heightMap)
diff --git a/game/core/src/main/java/net/minecraft/core/world/lighting/LightingEngineLegacy.java b/game/core/src/main/java/net/minecraft/core/world/lighting/LightingEngineLegacy.java
index 4290a2082..534e8f367 100644
--- a/game/core/src/main/java/net/minecraft/core/world/lighting/LightingEngineLegacy.java
+++ b/game/core/src/main/java/net/minecraft/core/world/lighting/LightingEngineLegacy.java
@@ -6,15 +6,12 @@ import net.minecraft.core.block.Blocks;
 import net.minecraft.core.enums.LightLayer;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.chunk.Chunk;
-import net.minecraft.core.world.pos.ChunkPos;
-import net.minecraft.core.world.pos.TilePos;
 import org.jetbrains.annotations.NotNull;
 import org.slf4j.Logger;
 
-import java.util.LinkedList;
 import java.util.List;
 
-import static net.minecraft.core.world.World.MAX_BRIGHTNESS;
+import static net.minecraft.core.world.World.MAX_LIGHT_LEVEL;
 
 public class LightingEngineLegacy implements LightingEngine {
     private static final Logger LOGGER = LogUtils.getLogger();
@@ -188,7 +185,7 @@ public class LightingEngineLegacy implements LightingEngine {
                         {
                             if(world.canExistingBlockSeeTheSky(x, y, z))
                             {
-                                blockLightValue = MAX_BRIGHTNESS;
+                                blockLightValue = MAX_LIGHT_LEVEL;
                             }
                         }
                         else if(this.layer == LightLayer.Block)
@@ -196,7 +193,7 @@ public class LightingEngineLegacy implements LightingEngine {
                             blockLightValue = Blocks.lightEmission[blockId];
                         }
 
-                        if(blockLightOpacity >= MAX_BRIGHTNESS && blockLightValue == 0)
+                        if(blockLightOpacity >= MAX_LIGHT_LEVEL && blockLightValue == 0)
                         {
                             newLightValue = 0;
                         }
@@ -291,7 +288,7 @@ public class LightingEngineLegacy implements LightingEngine {
             {
                 if(world.canExistingBlockSeeTheSky(x, y, z))
                 {
-                    lightValue = MAX_BRIGHTNESS;
+                    lightValue = MAX_LIGHT_LEVEL;
                 }
             }
             else if(lightLayer == LightLayer.Block)
